"use strict";
/*
 * @Description:
 * @Author: chenjiaxin
 * @Date: 2022-07-17 20:45:01
 * @LastEditTime: 2022-07-19 22:33:43
 * @FilePath: \rollup-plugin-compression\src\index.ts
 */
// const { cwd } = require("node:process");
// const path = require("path");
// const compressing = require("compressing");
// const chalk = require("chalk");
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_process_1 = require("node:process");
const path_1 = __importDefault(require("path"));
const compressing_1 = __importDefault(require("compressing"));
const fs_1 = __importDefault(require("fs"));
const defaultOption = {
    sourceName: "dist",
    type: "zip",
    targetName: "dist",
    ignoreBase: false //默认打包源文件夹本身,配置为true则只打包文件夹内文件
};
// 删除 目录 及 目录中的所有 目录和文件
const deleteDir = (targetPath) => {
    // 1. 判断 路径是否存在
    if (!fs_1.default.existsSync(targetPath))
        return;
    // 2. 获取该路径下所有目录名和文件名
    const files = fs_1.default.readdirSync(targetPath);
    files.forEach((file) => {
        // 3. 拼接 目录下的目录路径 和 文件路径
        const curPath = path_1.default.resolve(targetPath, file);
        // 4. 判断是否 是目录
        if (fs_1.default.statSync(curPath).isDirectory()) {
            // 是目录  递归删除里面的 文件
            deleteDir(curPath);
        }
        else {
            // 是文件 删除
            fs_1.default.unlinkSync(curPath);
        }
    });
    // 删除 目录
    fs_1.default.rmdirSync(targetPath);
};
const deleteDirFile = (targetPath, buildType) => {
    const rootPathFiles = fs_1.default.readdirSync(targetPath);
    // console.log("获取==根路径下文件", rootPathFiles);
    rootPathFiles.forEach((file) => {
        const currentPath = path_1.default.resolve(targetPath, file);
        // 判断是否是目录
        if (!fs_1.default.statSync(currentPath).isDirectory()) {
            // 不是目录 说明是文件
            // 获取文件扩展名
            const extname = path_1.default.extname(file);
            if (extname === `.${buildType}`) {
                // 判断是否 是 打包的文件  是 就删除文件
                fs_1.default.unlinkSync(currentPath);
            }
        }
        // console.log("根路劲下目录和文件", currentPath);
    });
};
const compressionBuild = (options = defaultOption) => {
    var _a, _b, _c;
    // const { sourceName, targetName = "dist" } = options;
    const sourceName = (_a = options.sourceName) !== null && _a !== void 0 ? _a : "dist";
    const type = (_b = options.type) !== null && _b !== void 0 ? _b : "zip";
    const targetName = (_c = options.targetName) !== null && _c !== void 0 ? _c : "dist";
    const rootPath = (0, node_process_1.cwd)();
    const buildPath = path_1.default.resolve(rootPath, sourceName);
    return {
        name: "compression",
        buildStart() {
            //1. 删除 build 构建目录
            deleteDir(buildPath);
            //2. 删除 目录下 指定的扩展名 文件
            deleteDirFile(rootPath, type);
        },
        closeBundle() {
            var _a;
            console.log("closeBundle");
            compressing_1.default.zip
                .compressDir(buildPath, `${targetName}.${type}`, { ignoreBase: (_a = options.ignoreBase) !== null && _a !== void 0 ? _a : false })
                .then((res) => {
                console.log("compress completed ~");
                // console.log(chalk.cyan(`compress-${sourceName}:  ${sourceName} compress completed!`));
            })
                .catch((err) => {
                // console.log(chalk.cyan(`compress error ~`));
            });
        }
    };
};
exports.default = compressionBuild;
//# sourceMappingURL=index.js.map